clear all
close all
clc

A = matriz_preg1_lab4_sparse(50, 4, 1, 1, -1);
D = diag(diag(A));
E = D - tril(A);
F = D - triu(A);

% Matrices de iteracion
Mjac = D\(E + F);
Mgs = (D - E) \ F;

% Radios espectrales (deben ser menores que uno para que el metodo sea
% convergente.
rjac = max(abs(eigs(Mjac)));
rgs = max(abs(eigs(Mgs)));

% Crear vector b, y valor inicial x0, definir maxiter como 100.
b = ones(50, 1);
x0 = zeros(50, 1);
maxiter = 100;

% Mostrar en pantalla la tabla
fprintf('----------------------------------------------\n')
fprintf('Tabla Metodos Jacobi y Gauss-Seidel\n')
fprintf('----------------------------------------------\n')
fprintf('%20s %20s %20s\n', 'iter jac', 'iter gs', 'norm(xj - xgs, inf)')
for tol = [1e-2, 1e-4, 1e-6]
    [xj, convj, iterj] = jacobisol(A, b, x0, tol, maxiter);
    [xgs, convgs, itergs] = gaussseidelsol(A, b, x0, tol, maxiter);
    fprintf('%20d %20d %20f\n', iterj, itergs, norm(xj - xgs, inf))
end

% Verificar que la matriz no es mal condicionada (no es mucho mayor que 1
% el numero de condicion de la matriz A
fprintf('\nEl numero de condicion de A es %f\n\n', condest(A))

fprintf('----------------------------------------------\n')
fprintf('Tabla Gradiente Conjugado\n')
fprintf('----------------------------------------------\n')
fprintf('%20s %20s\n', 'iteraciones GC', 'residuo relativo')
for tol = [1e-2, 1e-4, 1e-6]
    [xgc, flag, relres, iter] = pcg(A, b, tol);
    fprintf('%20d %20f\n', iter, relres)
end

A = gallery('poisson', 100);
fprintf('\nEl numero de condicion de la nueva matriz A es %f\n\n', condest(A))

% Observar que el numero de condicion de la nueva matriz A es mucho mayor
% que 1, por lo tanto esta muy mal condicionada.
b = ones(10000, 1);
[xgc, flag, relres, iter] = pcg(A, b, tol);

% Segun la documentacion de la funcion pcg (help pcg) si flag == 0,
% entonces el metodo convergio correctamente
if flag ~= 0
    disp('El metodo no convergio con la tolerancia deseada\n')
end

fprintf('----------------------------------------------\n')
fprintf('Tabla Gradiente Conjugado Precondicionado\n')
fprintf('----------------------------------------------\n')
fprintf('%20s %20s\n', 'iteraciones GCP', 'norm(P - A, inf)')
tol = 1e-3;
for tolp = [0.2, 0.01, 0.001]
    L = ichol(A, struct('type', 'ict', 'droptol', tolp));
    P = L*L';
    [xgc, flag, relres, iter] = pcg(A, b, tol, maxiter, P);
    fprintf('%20d %20f\n', iter, norm(P - A, inf))
end

% Todos los detalles de las funciones internas de MATLAB, se encuentran en
% la documentacion de las mismas, en este caso, para saber como usar pcg,
% solo basta con poner help pcg...




